leetcode 1两数之和

题目

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

示例 1:

输入:nums = 2,7,11,15, target = 9

输出:0,1

解释:因为 nums0 + nums1 == 9 ,返回 0, 1 。

示例 2:

输入:nums = 3,2,4, target = 6

输出:1,2

示例 3:

输入:nums = 3,3, target = 6

输出:0,1

解析

这道题是leetcode中的第一道题,应该也是很多人梦开始的地方,这道题可能有些人觉得他很简单,直接两层for循环就可以解决的事情,其实这是一道典型使用hash表解决的题目
使用那种哈希表来解决?

哈希表有三种实现方式,第一种使用数组来完成,第二种使用set集合来完成,第三种使用map来操作

在这里很明显是需要是要使用map来解决

map有三种实现方式

map和multimap底层使用红黑树来实现,还有一种就是使用unrodered_map来实现,这个的效率是最高的,增删改查的效率都是o(1)
为什么想到采用hash法来解决这道题

我们要查询一个元素是否在之前的遍历中是否出现过,避免一个元素的重复查询,通过这种方式来降低时间复杂度,就要第一时间想到哈希法

代码

复制代码
class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        //定义一个map来存放两个数据,这里使用到map来操作减低了复杂度,因为unordered_map的查找效率等等都是o(1)
        unordered_map<int,int> temp;
        for(int i=0;i<nums.size();i++){
            int res=target-nums[i];
            auto it=temp.find(res);
            if(it!=temp.end()){
                return {it->second,i};
            }
            // map存储的就是键对值,所以插入的时候插入的是pair对组
            temp.insert(pair<int,int>(nums[i],i));
        }return {};
    }
};
```
#  通过
![在这里插入图片描述](https://img-blog.csdnimg.cn/direct/041580e0121d4b8ebf15aec9e63aa384.png)
相关推荐
Nil2083 小时前
leetcode 198打家劫舍
算法·leetcode·职场和发展
mmmmath_33 小时前
LeetCode.429.N叉树的层序遍历
数据结构·leetcode
0+1116 小时前
算法 --哈希表
数据结构·算法·散列表
codigger7 小时前
哈希算法:一根看不见的 "指纹",如何撑起整个互联网
后端·区块链·哈希算法·sha256
刻BITTER8 小时前
LocalLow 乱码文件排查 Intel INSC着色器缓存文件
缓存·哈希算法·着色器
INGNIGHT9 小时前
593 · 石头游戏 II (区间dp石子合并 翻倍循环问题)
leetcode
aqiu1111119 小时前
【C++算法打怪专栏】LeetCode 402. 移掉 K 位数字(单调栈 + 贪心)
c++·算法·leetcode
第六种自由10 小时前
[路飞]_Leetcode 22. 括号生成
javascript·算法·leetcode
longlongzihan11 小时前
LeetCode 24.两两交换链表中的节点:虚拟头结点与指针
算法·leetcode·链表
Xin77011 小时前
LeetCode 105. 从前序与中序遍历序列构造二叉树(递归分治法)
leetcode